Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var cacheContext = require('./cacheContext.js');
var cacheReducer = require('./cacheReducer.js');
var cacheType = require('./cache-type.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/* eslint-disable react/destructuring-assignment */
var initialState = {};
var KeepAliveProvider = function (props) {
    var _a = React.useReducer(cacheReducer["default"], initialState), cacheStates = _a[0], dispatch = _a[1];
    var mount = React.useCallback(function (_a) {
        var _b;
        var cacheId = _a.cacheId, reactElement = _a.reactElement;
        if (!cacheStates[cacheId]) {
            dispatch({
                type: cacheType["default"].CREATE,
                payload: { cacheId: cacheId, reactElement: reactElement },
            });
        }
        else if (cacheStates[cacheId].status === cacheType["default"].DESTROY) {
            (_b = cacheStates[cacheId].doms) === null || _b === void 0 ? void 0 : _b.forEach(function (dom) {
                if (dom && dom.parentNode) {
                    dom.parentNode.removeChild(dom);
                }
            });
            dispatch({
                type: cacheType["default"].CREATE,
                payload: { cacheId: cacheId, reactElement: reactElement },
            });
        }
    }, [cacheStates]);
    var handleScroll = React.useCallback(function (cacheId, target) {
        if (cacheStates[cacheId] && target) {
            var scrolls = cacheStates[cacheId].scrolls;
            scrolls[target.baseURI] = target.scrollTop;
        }
    }, [cacheStates]);
    return (React__default["default"].createElement(cacheContext["default"].Provider, { value: { cacheStates: cacheStates, dispatch: dispatch, mount: mount, handleScroll: handleScroll } },
        props.children,
        Object.values(cacheStates)
            .filter(function (cacheState) { return cacheState.status !== cacheType["default"].DESTROY; })
            .map(function (state) {
            var cacheId = state.cacheId, reactElement = state.reactElement;
            return (React__default["default"].createElement("div", { id: "cache-".concat(cacheId), key: cacheId, ref: function (divDom) {
                    var cacheState = cacheStates[cacheId];
                    if (divDom &&
                        (!cacheState.doms || cacheState.status === cacheType["default"].DESTROY)) {
                        var doms = Array.from(divDom.children);
                        dispatch({
                            type: cacheType["default"].CREATED,
                            payload: { cacheId: cacheId, reactElement: reactElement, doms: doms },
                        });
                    }
                } }, reactElement));
        })));
};

exports["default"] = KeepAliveProvider;
//# sourceMappingURL=KeepAliveProvider.js.map
