Object.defineProperty(exports, '__esModule', { value: true });

var _tslib = require('./_virtual/_tslib.js');
var React = require('react');
var cacheContext = require('./cacheContext.js');
var cacheType = require('./cache-type.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var withKeepAlive = function (OldComponent, _a) {
    var _b = _a.cacheId, cacheId = _b === void 0 ? window.location.pathname : _b, scroll = _a.scroll;
    return function (props) {
        var _a = React.useContext(cacheContext["default"]), cacheStates = _a.cacheStates, dispatch = _a.dispatch, mount = _a.mount, handleScroll = _a.handleScroll;
        var divRef = React.useRef(null);
        var cacheDestroy = React.useCallback(function (cacheId) { return function () {
            dispatch({ type: cacheType["default"].DESTROY, payload: { cacheId: cacheId } });
        }; }, [cacheId]);
        React.useEffect(function () {
            var _a;
            var onScroll = function (event) {
                return handleScroll(cacheId, event.target);
            };
            if (divRef.current && scroll) {
                divRef.current.addEventListener('scroll', onScroll, 
                // ts需要制定target类型，事件的ts无法确定类型
                true);
            }
            return (_a = divRef.current) === null || _a === void 0 ? void 0 : _a.removeEventListener('scroll', onScroll);
        }, [handleScroll]);
        React.useEffect(function () {
            var cacheState = cacheStates[cacheId];
            if (
            // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
            cacheState &&
                cacheState.doms &&
                cacheState.status !== cacheType["default"].DESTROY) {
                var doms = cacheState.doms;
                doms.forEach(function (dom) {
                    if (divRef.current) {
                        divRef.current.appendChild(dom);
                        if (scroll && cacheState.scrolls[dom.baseURI]) {
                            dom.scrollTop = cacheState.scrolls[dom.baseURI];
                        }
                    }
                });
            }
            else {
                mount({
                    cacheId: cacheId,
                    reactElement: React__default["default"].createElement(OldComponent, _tslib.__assign({}, props, { cacheDestroy: cacheDestroy })),
                });
            }
        }, [props, cacheStates, mount]);
        return React__default["default"].createElement("div", { id: "withKeepAlive".concat(cacheId), ref: divRef });
    };
};

exports["default"] = withKeepAlive;
//# sourceMappingURL=withKeepAlive.js.map
